(* HCoop Domtool (http://hcoop.sourceforge.net/)
 * Copyright (c) 2006, Adam Chlipala
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*)

(* Domtool type-checking and reduction environments *)

signature ENV = sig

    type typeRule = Ast.exp -> bool
    val registerType : string * typeRule -> unit
    val typeRule : string -> typeRule option

    type env_vars = Ast.exp Ast.StringMap.map
    type action = env_vars * Ast.exp list -> env_vars
    val registerAction : string * action -> unit
    val action : string -> action option

    val registerContainer : string * action * (unit -> unit) -> unit
    val container : string -> (action * (unit -> unit)) option

    val badArgs : string -> 'a

    type env
    val empty : env

    val bindType : env -> string -> env
    val bindVal : env -> string * Ast.typ * Ast.exp option -> env

    val lookupType : env -> string -> bool
    val lookupVal : env -> string -> Ast.typ option
    val lookupEquation : env -> string -> Ast.exp option

end
